/* Compact.c -- a subroutine that takes a FORTRAN string and rips out
   unnecessary blanks -- it reduces multiple blanks to singles whereever
   they occur. Called from FORTRAN by
	CALL COMPACT(STRING,ILEN)
   STRING is a character variable to be compacted. Upon return, ILEN
   holds the "useful length" of STRING, which has had all leading
   and trailing blanks eliminated, and duplicate blanks reduced to single.
*/

#include <string.h>
#include <ctype.h>

compact_(string,ilen,len)
char *string;
int *ilen,len;
{
  int spcfound,nscanned;
  char *tmpstr,*calloc();
  char *p1,*p2;
  
  p1 = string;
  p2 = tmpstr = calloc(len,1);
  /* First, skip over leading blanks. */
  for(nscanned = 0;(nscanned++<len)&&isspace(*p1);p1++) 
    ; 
  if (nscanned < len) {  /* Something useful in string */
    spcfound = 0;
    do {
      if(!(spcfound&&isspace(*p1)))
        *(p2++) = *p1;
      spcfound = isspace(*p1++);
      nscanned++;
    } while(nscanned<len);
  }
  while (isspace(*--p2)) 
    ; /* Remove trailing blanks */
  *ilen = p2 - tmpstr + 1; /* Number of useful characters copied */
  strncpy(string,tmpstr,*ilen);
  /* pad the rest out with blanks */
  for(nscanned= *ilen;nscanned<len;*(string+nscanned++)=' ')
    ;
  cfree(tmpstr);
}

