c
      subroutine dashln (x, y, dash, ipen)
c
c$$$$$ calls plot
c
c  near plug in substitute for calcomp 'plot' giving dashed lines if
c  dash(1) is positive and 'plot' if it is not. must call with ipen=3 and
c  dash(1) positive to initialize routine
c
c  x        is the x-coordinate of the pen move
c  y        is the y-coordinate of the pen move
c  dash(1)  is the length of the nonblank segments of the dashed lines
c             (if negative, dashed line feature disabled)
c  dash(2)  is the length of the blank segments of the dashed lines
c  ipen     is the calcomp pen call (= -3, -2, 2, 3, 998 or 999)
c             (= 3  re-initializes dashed line routine if dash(1).gt.0.0)
c
      real dash(2)
      save xo,yo,ink,snext
      data xo,yo,snext,ink/0.,0.,0.,3/
c
c  check if dashed-line feature is needed or not.
      if (dash(1).le. 0.0) then
         call plot(x, y, ipen)
         return
      end if
 
      go to (1400, 1200, 1300), ipen
      go to 1400
 
c  draw a section of dashed line.  s  is the length of the current segment.
 1200 s=sqrt((x-xo)**2 + (y-yo)**2)
      if (s.eq. 0.0) return
      nseg=2.0 + 2.0*s/(dash(1) + dash(2))
      do 1250 l=1, nseg
         r=amin1(1.0, snext/s)
         call plot(xo + r*(x-xo), yo + r*(y-yo), ink)
         if (s .lt. snext) go to 1260
         ink=5 - ink
 1250    snext=dash(ink-1) + snext
 1260 snext=snext - s
      xo=x
      yo=y
      return
 
c  re-initialize dashed parameters and move with pen lifted.
 1300 xo=x
      yo=y
      snext=0.0
      ink=3
      call plot(x, y, ipen)
      return
 
c  odd call -- check for negative ipen returning otherwise
c
c  re-origin and re-initialize
1400  if (ipen.eq.-3) then
         snext=0.0
         ink=3
         xo=0.
         yo=0.
         call plot(x, y, ipen)
         return
 
c  re-origin and re-initialize but first draw a section of dashed line.
      else if (ipen.eq.-2) then
         s=sqrt((x-xo)**2 + (y-yo)**2)
         if (s.eq. 0.0) return
         nseg=2.0 + 2.0*s/(dash(1) + dash(2))
         do 1500 l=1, nseg
            r=amin1(1.0, snext/s)
            call plot(xo + r*(x-xo), yo + r*(y-yo), ink)
            if (s .lt. snext) go to 1510
            ink=5 - ink
 1500       snext=dash(ink-1) + snext
 1510    snext=snext - s
         call plot(x, y, ipen)
         snext=0.0
         ink=3
         xo=0.
         yo=0.
      end if
      return
      end
