c
      subroutine lgaxes(xx,yy,xlen, x1,x2, ixy)
c
c neat subroutine to plot log axes -- r.l. parker & l. shure
c                                  -- modified by k. mackenzie
c$$$$$ calls plot, symbol, justfy, axes
c
c  plots either an x- or a y-axis beginning at position (xx,yy)
c   (in inches) of length  xlen (inches) with logarithmically
c  spaced tick marks and annotation between the limits  x1, x2.
c  x1 may be greater or less than x2 (allowing reversed axis).
c  the axis may be set to be any of the four sides of a plot:
c  --- ticks labeled with numbers
c  ixy =1 means x-axis (for the bottom), ixy =-1 means x-axis (for the top)
c  ixy =2 means y-axis (for the left),   ixy =-2 means y-axis (for the right).
c  --- ticks not labeled
c  ixy =3 means x-axis (for the bottom), ixy =-4 means x-axis (for the top)
c  ixy =4 means y-axis (for the left),   ixy =-4 means y-axis (for the right).
c
      character*4 clabel
      dimension s(4)
      integer*4 label, no(10)
      logical qnum
      common /backs/ backy, ht
      common /ilogik/ logik, xs
      data no /'1   ', '2   ', '3   ', '4   ', '5   ',
     .         '6   ', '7   ', '8   ', '9   ', '10  '/
      data ht /0.15/
      save
c
      iten(x)= int (500.01 + alog10(x)) - 500
c
      qnum= .true.
      htix= .1
      iyx= ixy
      if (iyx .lt. 0) then
        iyx= iabs (iyx)
        htix= -.1
      end if
      if (iyx .gt. 2) then
        qnum= .false.
        iyx= iyx - 2
      end if
      log1= iten (x1)
      log2= iten (x2)
      xs= xlen / alog10 (x2/x1)
      if (log2 .eq. log1) go to 4000
      hr= 0.75* ht
      call justfy (s, ht, no(10), 2)
      wid10= s(3)
      call plot (xx, yy, 3)
c  select x- or y- axis.
      go to (2100, 3100), iyx
c
c  plot x axis.
 2100 back= 0.5 * wid10
      if (htix .lt. 0.) then
         xlab1= .5*ht + yy
         xlab2= ht + yy
         xlab3= hr + yy
      else
         xlab1= -2.*ht + yy
         xlab2= -1.5*ht + yy
         xlab3= -2.*hr + yy
      end if
      htic= yy + htix
      do 2500 kdec= log1, log2
      do 2400 numb= 1, 9
      xinch= xs * (alog10 (numb/x1) + kdec)
      if (xinch .lt. -0.01 .or. xinch .gt. 0.01+xlen) go to 2400
c  draw next section of axis and its tick mark.
      xinch= xinch + xx
      call plot (xinch, yy, 2)
      call plot (xinch, htic, 2)
      if (numb .ne. 1) go to 2200
c  write out the notation 10**kdec below the appropriate tick.
      write (clabel(1:4), '(i4)') kdec
      read (clabel(1:4), '(a4)') label
      call justfy (s, hr, label, 4)
      if (qnum) then
         call symbol (xinch-back, xlab1, ht, no(10), 0.0, 2)
         call symbol (xinch+back-s(1), xlab2, hr, label, 0.0, 4)
      end if
      go to 2450
c  if number of decades .lt.2 write the integers next to their ticks.
 2200 if (log2-log1 .le. 2  .and. .02*xs .gt. ht .and. qnum)
     .   call symbol (xinch-0.5*hr, xlab3, hr, no(numb), 0.0, 2)
c  move back onto the axis with the pen raised.
 2450 call plot (xinch, yy, 3)
 2400 continue
 2500 continue
c  plot last piece of the axis and thicken axis.
      xxx= xx + xlen
      call plot (xxx, yy, 2)
      yyy= yy + sign (.008, htix)
      call plot (xxx, yyy, 2)
      call plot (xx, yyy, 2)
      call plot (xx, yy, 3)
c  return to calling program
      return
c
c  plot y axis.
 3100 backy= 2.0 * wid10
      htic= xx + htix
      do 3500 kdec= log1, log2
      do 3400 numb= 1, 9
      xinch= xs * (alog10 (numb/x1) + kdec)
      if (xinch .lt. -0.01 .or. xinch .gt. 0.01+xlen) go to 3400
c  draw next section of axis and its tick mark.
      xinch= xinch + yy
      call plot (xx, xinch,  2)
      call plot (htic, xinch, 2)
      if (numb .ne. 1) go to 3200
c  write out the notation 10**kdec below the appropriate tick.
      write (clabel(1:4), '(i4)') kdec
      read (clabel(1:4), '(a4)') label
      call justfy (s, hr, label, 4)
      back= 1.5*wid10 + s(3) - s(1)
      backy= amax1 (back, backy)
      if (htix .lt. 0.) then
         ylab1= .5*wid10 + xx
         ylab2= 1.5*wid10 + s(1) + xx
      else
         ylab1= -back + xx
         ylab2= wid10 - back - s(1) + xx
      end if
      if (qnum) then
         call symbol(ylab1, xinch-0.5*ht, ht, no(10), 0.0, 2)
         call symbol(ylab2, xinch, hr, label, 0.0, 4)
      end if
      go to 3450
c  if number of decades .lt. 2, write the integers next to their ticks.
 3200 if (log2-log1 .le. 2  .and. .02*xs .gt. ht)then
         if(htix .lt. 0.) then
            ylab3= hr + xx
         else
            ylab3= -1.5*hr + xx
         end if
         if(qnum) then
            call symbol (ylab3, xinch-0.5*hr, hr, no(numb), 0.0, 2)
         end if
      end if
c  move back onto the axis with the pen raised.
 3450 call plot (xx, xinch, 3)
 3400 continue
 3500 continue
c  plot last piece of the axis and thicken axis.
      yyy= yy+ xlen
      call plot (xx, yyy, 2)
      xxx= xx + sign (.008, htix)
      call plot (xxx, yyy, 2)
      call plot (xxx, yy,  2)
      call plot (xx, yy, 3)
c  return to calling program
      return
c
c  interval too short to contain an exact power of ten.  use standard
c  axes  routine with logarithmic stretching option through /ilogik/
 4000 logik= 1
      call axes (xx, yy, xlen, x1, x2, ixy)
      logik= 0
c  return to calling program
      return
      end
