c
      subroutine nicer (xin, xout, xtick)
c
c$$$$$ calls only standard library routines
c
c  routine for scaling intervals and providing tick marks for plotter axes.
c  between 7 and 15 ticks are made, which is suitable for 10 inch axes.
c    input parameters
c  xin(1),xin(2)  extremes of variable  x  in its own units
c    output parameters
c  xout(1),xout(2)  adjusted extremes, made to be round numbers.  note new
c    interval always covers old one.
c  xtick  distance between tick marks in  x  units (not inches).  this
c    number is always a round number.
      dimension  divs(4),xin(2),xout(2)
      data e/1.0e-7/,divs/.1,.2,.5,1.0/
      save
c
      xout(1)=xin(1)
      xout(2)=xin(2)
      if (xout(2).eq.xout(1)) xout(2)=1.0 + 1.1*xout(2)
      plus=1000.0+alog10(abs(xout(2)-xout(1)))
      index=1.4969 + 2.857*amod(plus,1.0)
      units=divs(index)*10.0**(int(plus)-1000)
      bias=(1.+e)*units*aint(1.+amax1(abs(xout(1)),abs(xout(2)))/units)
      xout(1)=xout(1) - sign(amod(xout(1)+bias,units),xin(2)-xin(1))
      xout(2)=xout(2) - sign(amod(xout(2)-bias,units),xin(2)-xin(1))
      if (abs(xout(1)/units) .le. .01) xout(1)=0.0
      if (abs(xout(2)/units) .le. .01) xout(2)=0.0
      xtick=sign(units,xin(2)-xin(1))
      return
      end
