c
      subroutine number (xx, yy, height, fpnum, theta, fmtstr)
c
c number routine to plot floating point number <fpnum> according to format
c <fmtstr> at location <xx,yy> at <theta> degrees rotation and <height> inches
c tall. formats may be 'f', 'e' (or '1pe'), or 'i'.  only the first 20
c characters in <fmtstr> will be used as the format.  imbedded blanks are ok.
c number to be plotted must have 20 or fewer digits including signs, decimal
c point, and any exponent.
c
c calls symbol to plot the number
c                                       k. mackenzie  4/8/83
c
      character*(*) fmtstr
      character*20 numstr, numfmt, temfmt, dumnumfmt
      integer*4 places, digit, maxlen, inum, itext(5)
      real xx, yy, height, fpnum, theta, fnum, enum
      save
 
c find length of character string containing format to be plotted
      m=len(fmtstr)
      n=0
      do 5 i=m,1,-1
         if (fmtstr(i:i).ne.' ') then
            n=i
            go to 6
         end if
5        continue
 
c go through and remove any imbedded blanks
6     if (n.gt.20) go to 90
      numfmt(1:n)=fmtstr(1:n)
7     j=index(numfmt(1:n),' ')
      if (j.ne.0) then
         dumnumfmt(j:n-1)=numfmt(j+1:n)
         n=n-1
         numfmt(j:n)=dumnumfmt(j:n)
         go to 7
      end if
      if (n.lt.2) go to 90
 
c parse the character string into the right format, determining
c the requested number length and number of decimal places.
10    continue
      if((numfmt(1:1).eq.'e'.or.numfmt(1:1).eq.'e'
     *    .or.numfmt(1:1).eq.'f'.or.numfmt(1:1).eq.'f').and.n.gt.2) then
 
c -- its an 'f' or an 'e' format
         if(lge(numfmt(2:2),'0').and.lle(numfmt(2:2),'9')) then
            read(numfmt(2:2),'(i1)') digit
            maxlen=digit
         else
            go to 90
         end if
         if (numfmt(3:3).eq.'.') then
            i=4
            go to 20
         else if (lge(numfmt(3:3),'0').and.lle(numfmt(3:3),'9')) then
            read(numfmt(3:3),'(i1)') digit
            maxlen=maxlen*10 + digit
         else
            go to 90
         end if
         if (numfmt(4:4).ne.'.') then
            go to 90
         end if
         i=5
20       if(llt(numfmt(i:i),'0').or.lgt(numfmt(i:i),'9')) then
            go to 90
         end if
      else if ((numfmt(1:1).eq.'i'.or.numfmt(1:1).eq.'i')
     *                                             .and.n.lt.4) then
 
c -- its an 'i' format
         if(lge(numfmt(2:2),'0').and.lle(numfmt(2:2),'9')) then
            read(numfmt(2:2),'(i1)') digit
            maxlen=digit
         else
            go to 90
         end if
         if(lge(numfmt(3:3),'0').and.lle(numfmt(3:3),'9')) then
            read(numfmt(3:3),'(i1)') digit
            maxlen=maxlen*10 + digit
         else if (n.gt.2) then
            go to 90
         end if
      else if (numfmt(1:3).eq.'1pe'.or.numfmt(1:3).eq.'1pe') then
 
c -- its an '1pe' format
         dumnumfmt(1:n-2)=numfmt(3:n)
         n=n-2
         numfmt(1:n)=dumnumfmt(1:n)
         go to 10
      else
 
c -- its garbage
         go to 90
      end if
30    maxlen=min0(maxlen,20)
 
c now set up a character buffer (max length = 20 characters) containing
c the number spelled out in the requested format
      if (numfmt(1:1).eq.'f'.or.numfmt(1:1).eq.'f') then
 
c -- f format
         fnum=fpnum
         temfmt(1:2)='(f'
         temfmt(3:n+1)=numfmt(2:n)
         temfmt(n+2:n+2)=')'
         write (numstr(1:maxlen),temfmt) fnum
      else if (numfmt(1:1).eq.'e'.or.numfmt(1:1).eq.'e') then
 
c -- e format
         enum=fpnum
         temfmt(1:4)='(1pe'
         temfmt(5:n+3)=numfmt(2:n)
         temfmt(n+4:n+4)=')'
         write (numstr(1:maxlen),temfmt) enum
      else
 
c -- i format
         inum=int(fpnum)
         temfmt(1:2)='(i'
         temfmt(3:n+1)=numfmt(2:n)
         temfmt(n+2:n+2)=')'
         write (numstr(1:maxlen),temfmt) inum
      end if
 
c plot the number with routine symbol
      read (numstr(1:maxlen),'(5a4)') itext
      call symbol(xx,yy,height,itext,theta,maxlen)
      return
 
c error -- undecipherable format
90    call symbol(xx,yy,height,'???',theta,3)
      return
      end
